package sun.management.snmp.util;

import java.util.Iterator;
import java.util.TreeMap;
import com.sun.jmx.snmp.SnmpOid;
import java.util.List;

public abstract class SnmpListTableCache extends SnmpTableCache
{
    public SnmpListTableCache() {
    }
    
    protected abstract SnmpOid getIndex(Object p0, List<?> p1, int p2, Object p3);
    
    protected Object getData(Object o, List<?> list, int n, Object o2) {
        return o2;
    }
    
    protected SnmpCachedData updateCachedDatas(Object o, List<?> list) {
        if (((list == null) ? 0 : list.size()) == 0) {
            return null;
        }
        long currentTimeMillis = System.currentTimeMillis();
        Iterator<Object> iterator = list.iterator();
        TreeMap treeMap = new TreeMap(SnmpCachedData.oidComparator);
        for (int n = 0; iterator.hasNext(); ++n) {
            Object next = iterator.next();
            SnmpOid index = this.getIndex(o, list, n, next);
            Object data = this.getData(o, list, n, next);
            if (index != null) {
                treeMap.put(index, data);
            }
        }
        return new SnmpCachedData(currentTimeMillis, treeMap);
    }
}
